/***************************************************************************
                          apollonsearchitemview.h  -  description
                             -------------------
begin		: Dec 05 2003
copyright	: (C) 2002 by Bastiaan Naber, (C) 2002 by Robert Wittams
email		: bastiaan@ricardis.tudelft.nl
description	: 

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef APOLLONSEARCHVIEWITEM_H
#define APOLLONSEARCHVIEWITEM_H

#include <qlistview.h>
#include <qstring.h> 
#include <qdict.h>

class ApollonSearchViewItemChild;

class ApollonSearchViewItem : public QListViewItem  
{
public:
	ApollonSearchViewItem( QListView * parent );
	ApollonSearchViewItem( QListViewItem * parent );
	~ApollonSearchViewItem();
	QString text ( int col) const;

	QString key ( int column, bool ascending ) const;
	int compare( QListViewItem* item, int column, bool ascending ) const;

	QString getUser() { return user; };
	QString getHash() { return hash; };
	QString getSize() { return size; };
	QString getUrl() { return url; };
	QString getFileName() { return file; };
	QString getAlbum() { return album; };
	QString getDuration() { return duration; };
	QString getBitrate() { return bitrate; };
        int getOpenSlots() { return openslots.toInt();};
	int getAvailSlots() { return mAvailSlots;};

	void addSource( const QString& );
	
	virtual void paintCell ( QPainter * p, const QColorGroup & cg, int column, int width, int align );
	
	QDict<ApollonSearchViewItemChild> children;
	
	void setUser( QString setuser )
	{
		user = setuser;
	}
	
	void setHash( QString sethash )
	{
		hash = sethash;
	}

	void setSize( QString setsize )
	{
		size = setsize;
	}

	void setUrl( QString seturl )
	{
		url = seturl;
	}

	void setFileName( QString setfile )
	{
		file = setfile;
	}
	
	void setOpenSlots( QString setslots )
	{
		openslots = setslots;
	}

	void setAlbum(QString setalbum) 
	  {
	    album = setalbum;
	  }

	void setDuration(QString setduration)
	  {
	  duration = setduration;
	  }

	void setBitrate(QString setbitrate)
	  {
	    bitrate = setbitrate;
	  }

 protected:
	
	QString user;
	 QString hash;
	 QString size;
	 QString url;
	 QString file;
	 QString duration;
	 QString openslots;
	 QString album;
	 QString bitrate;
	 
  private:
  	int mAvailSlots;
};

#endif
